/**************************************************************************

	WWWC (upMail.dll)

	Option.c

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.	
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/


/**************************************************************************
	Include Files
**************************************************************************/

#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <commctrl.h>

#include "CreateBody.h"
#include "wwwcdll.h"
#include "resource.h"


/**************************************************************************
	Define
**************************************************************************/

#define BUF_SIZE			256					/* obt@TCY */
#define FMT_SIZE			32768				/* obt@TCY */

#define IDPCANCEL			(WM_USER + 100)		//vpeBV[g̃LZbZ[W


/**************************************************************************
	Global Variables
**************************************************************************/

static HINSTANCE ghinst;
static HWND WWWCWnd;

extern char CuDir[];

extern char Name[];						/* { */
extern char MailAddress[];				/* [AhX */
extern char ServerName[];				/* SMTPT[o */
extern char ServerPort[];				/* |[gԍ */

extern int SendCheckType;
extern int SendAutoCheck;

extern char ToMailAddress[];			/* M惁[AhX */
extern char ToAddress[100][BUF_SIZE];
extern int ToAddressCnt;
extern char Subject[];					/*  */

extern char ListFormat[];
extern char Header[];
extern char Footer[];

extern int TargetFlag;
extern char TargetDir[100][BUF_SIZE];
extern int TargetDirCnt;


/******************************************************************************

	CharToFmt

	̕ϊ

******************************************************************************/

void CharToFmt(char *buf, char *ret)
{
	char *p, *r;

	for(p = buf, r = ret; *p != '\0'; p++){

		if((r - ret) > FMT_SIZE - 10) break;

		if(IsDBCSLeadByte((BYTE)*p) == TRUE){
			*(r++) = *(p++);
			*(r++) = *p;
			continue;
		}
		switch(*p)
		{
		case '\r':
			*(r++) = '\\';
			*(r++) = 'r';
			break;

		case '\n':
			*(r++) = '\\';
			*(r++) = 'n';
			break;

		case '\t':
			*(r++) = '\\';
			*(r++) = 't';
			break;

		case '\\':
			*(r++) = '\\';
			*(r++) = '\\';
			break;

		default:
			*(r++) = *p;
			break;
		}
	}
	*r = '\0';
}


/******************************************************************************

	InputProc

	[AhX̓_CAO

******************************************************************************/

static BOOL CALLBACK InputProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char *buf;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		if((char *)lParam == NULL){
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		SendMessage(GetDlgItem(hDlg, IDC_EDIT_MAILADDRESS), WM_SETTEXT, BUF_SIZE - 1, (LPARAM)lParam);
		break;

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			buf = (char *)GetWindowLong(hDlg, GWL_USERDATA);
			if(buf == NULL){
				EndDialog(hDlg, FALSE);
				break;
			}
			SendMessage(GetDlgItem(hDlg, IDC_EDIT_MAILADDRESS), WM_GETTEXT, BUF_SIZE - 1, (LPARAM)buf);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	OptionNotifyProc

	vpeBV[g̃Cxg̒ʒm

******************************************************************************/

static LRESULT OptionNotifyProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	PSHNOTIFY *pshn = (PSHNOTIFY FAR *) lParam;
	NMHDR *lpnmhdr = (NMHDR FAR *)&pshn->hdr;

	switch(lpnmhdr->code)
	{
	case PSN_APPLY:				//OK
		SendMessage(hDlg, WM_COMMAND, IDOK, 0);
		break;

	case PSN_QUERYCANCEL:		//LZ
		SendMessage(hDlg, WM_COMMAND, IDPCANCEL, 0);
		break;

	default:
		return PSNRET_NOERROR;
	}
	return PSNRET_NOERROR;
}


/******************************************************************************

	OptionSendProc

	Mݒ_CAO

******************************************************************************/

static BOOL CALLBACK OptionSendProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char ini_path[BUF_SIZE];
	char buf[BUF_SIZE];

	switch (uMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_SETTEXT, 0, (LPARAM)Name);
		SendDlgItemMessage(hDlg, IDC_EDIT_MAILADDRESS, WM_SETTEXT, 0, (LPARAM)MailAddress);

		SendDlgItemMessage(hDlg, IDC_EDIT_SERVER_NAME, WM_SETTEXT, 0, (LPARAM)ServerName);
		SendDlgItemMessage(hDlg, IDC_EDIT_SERVER_PORT, WM_SETTEXT, 0, (LPARAM)ServerPort);

		if(SendCheckType & CHECKTYPE_ITEM){
			CheckDlgButton(hDlg, IDC_CHECK_ITEM, 1);
		}
		if(SendCheckType & CHECKTYPE_ALL){
			CheckDlgButton(hDlg, IDC_CHECK_ALL, 1);
		}
		if(SendCheckType & CHECKTYPE_TREE){
			CheckDlgButton(hDlg, IDC_CHECK_TREE, 1);
		}
		if(SendCheckType & CHECKTYPE_ERROR){
			CheckDlgButton(hDlg, IDC_CHECK_ERROR, 1);
		}
		CheckDlgButton(hDlg, IDC_CHECK_AUTOCHECK, SendAutoCheck);
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			SendDlgItemMessage(hDlg, IDC_EDIT_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)Name);
			SendDlgItemMessage(hDlg, IDC_EDIT_MAILADDRESS, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)MailAddress);

			SendDlgItemMessage(hDlg, IDC_EDIT_SERVER_NAME, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)ServerName);
			SendDlgItemMessage(hDlg, IDC_EDIT_SERVER_PORT, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)ServerPort);

			SendCheckType = 0;
			if(IsDlgButtonChecked(hDlg, IDC_CHECK_ITEM) == 1){
				SendCheckType |= CHECKTYPE_ITEM;
			}
			if(IsDlgButtonChecked(hDlg, IDC_CHECK_ALL) == 1){
				SendCheckType |= CHECKTYPE_ALL;
			}
			if(IsDlgButtonChecked(hDlg, IDC_CHECK_TREE) == 1){
				SendCheckType |= CHECKTYPE_TREE;
			}
			if(IsDlgButtonChecked(hDlg, IDC_CHECK_ERROR) == 1){
				SendCheckType |= CHECKTYPE_ERROR;
			}

			SendAutoCheck = IsDlgButtonChecked(hDlg, IDC_CHECK_AUTOCHECK);

			wsprintf(ini_path, "%s\\upMail.ini", CuDir);
			WritePrivateProfileString("SEND", "Name", Name, ini_path);
			WritePrivateProfileString("SEND", "MailAddress", MailAddress, ini_path);
			WritePrivateProfileString("SEND", "ServerName", ServerName, ini_path);
			WritePrivateProfileString("SEND", "ServerPort", ServerPort, ini_path);

			wsprintf(buf, "%d", SendCheckType);
			WritePrivateProfileString("SEND", "SendCheckType", buf, ini_path);
			wsprintf(buf, "%d", SendAutoCheck);
			WritePrivateProfileString("SEND", "SendAutoCheck", buf, ini_path);
			break;

		case IDPCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	OptionHeaderProc

	wb_ݒ_CAO

******************************************************************************/

static BOOL CALLBACK OptionHeaderProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char ini_path[BUF_SIZE];
	char buf[BUF_SIZE];
	int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage(hDlg, IDC_EDIT_SUBJECT, WM_SETTEXT, 0, (LPARAM)Subject);
		for(i = 0; i < ToAddressCnt; i++){
			if(*(ToAddress[i]) != '\0'){
				SendDlgItemMessage(hDlg, IDC_LIST_TO, LB_ADDSTRING, 0, (LPARAM)ToAddress[i]);
			}
		}
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_BUTTON_ADD:
			if(SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_GETCOUNT, 0, 0) >= 100){
				break;
			}
			*buf = '\0';
			if(DialogBoxParam(ghinst, MAKEINTRESOURCE(IDD_DIALOG_INPUTADDR), hDlg, InputProc, (LPARAM)buf) == FALSE){
				break;
			}
			if(*buf == '\0'){
				break;
			}
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_ADDSTRING, 0, (LPARAM)buf);
			break;

		case IDC_BUTTON_EDIT:
			i = SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_GETCURSEL, 0, 0);
			if(i < 0) break;

			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_GETTEXT, i, (LPARAM)buf);
			if(DialogBoxParam(ghinst, MAKEINTRESOURCE(IDD_DIALOG_INPUTADDR), hDlg, InputProc, (LPARAM)buf) == FALSE){
				break;
			}
			if(*buf == '\0'){
				break;
			}
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_DELETESTRING, i, 0);
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_INSERTSTRING, i, (LPARAM)buf);
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_SETCURSEL, i, 0);
			break;

		case IDC_BUTTON_DELETE:
			i = SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_GETCURSEL, 0, 0);
			if(i < 0 || MessageBox(hDlg, "폜Ă낵łH", "폜", MB_ICONQUESTION | MB_YESNO) == IDNO){
				break;
			}
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_DELETESTRING, i, 0);
			SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_SETCURSEL, i, 0);
			break;

		case IDOK:
			SendDlgItemMessage(hDlg, IDC_EDIT_SUBJECT, WM_GETTEXT, BUF_SIZE - 1, (LPARAM)Subject);

			ToAddressCnt = SendMessage(GetDlgItem(hDlg, IDC_LIST_TO), LB_GETCOUNT, 0, 0);
			for(i = 0; i < ToAddressCnt; i++){
				SendDlgItemMessage(hDlg, IDC_LIST_TO, LB_GETTEXT, i, (LPARAM)ToAddress[i]);
			}

			wsprintf(ini_path, "%s\\upMail.ini", CuDir);
			WritePrivateProfileString("HEADER", NULL, NULL, ini_path);

			WritePrivateProfileString("HEADER", "Subject", Subject, ini_path);
			
			wsprintf(buf, "%d", ToAddressCnt);
			WritePrivateProfileString("HEADER", "ToAddressCnt", buf, ini_path);
			for(i = 0; i < ToAddressCnt; i++){
				wsprintf(buf, "ToAddress-%d", i);
				WritePrivateProfileString("HEADER", buf, ToAddress[i], ini_path);
			}
			break;

		case IDPCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	OptionMakeProc

	쐬ݒ_CAO

******************************************************************************/

static BOOL CALLBACK OptionMakeProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char ini_path[BUF_SIZE];
	char buf[FMT_SIZE];

	switch (uMsg)
	{
	case WM_INITDIALOG:
		FmtToString(ListFormat, buf);
		SendDlgItemMessage(hDlg, IDC_EDIT_FORMAT, WM_SETTEXT, 0, (LPARAM)buf);

		FmtToString(Header, buf);
		SendDlgItemMessage(hDlg, IDC_EDIT_HEADER, WM_SETTEXT, 0, (LPARAM)buf);
		FmtToString(Footer, buf);
		SendDlgItemMessage(hDlg, IDC_EDIT_FOOTER, WM_SETTEXT, 0, (LPARAM)buf);
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDOK:
			SendDlgItemMessage(hDlg, IDC_EDIT_FORMAT, WM_GETTEXT, FMT_SIZE - 1, (LPARAM)buf);
			CharToFmt(buf, ListFormat);
			SendDlgItemMessage(hDlg, IDC_EDIT_HEADER, WM_GETTEXT, FMT_SIZE - 1, (LPARAM)buf);
			CharToFmt(buf, Header);
			SendDlgItemMessage(hDlg, IDC_EDIT_FOOTER, WM_GETTEXT, FMT_SIZE - 1, (LPARAM)buf);
			CharToFmt(buf, Footer);

			wsprintf(ini_path, "%s\\upMail.ini", CuDir);
			WritePrivateProfileString("MAKE", "ListFormat", ListFormat, ini_path);
			WritePrivateProfileString("MAKE", "Header", Header, ini_path);
			WritePrivateProfileString("MAKE", "Footer", Footer, ini_path);
			break;

		case IDPCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	OptionFolderProc

	Ώېݒ_CAO

******************************************************************************/

static BOOL CALLBACK OptionFolderProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	char ini_path[BUF_SIZE];
	char buf[BUF_SIZE];
	int i;

	switch (uMsg)
	{
	case WM_INITDIALOG:
		if(TargetFlag == 0){
			CheckDlgButton(hDlg, IDC_RADIO_ALL, 1);
			EnableWindow(GetDlgItem(hDlg, IDC_LIST_FOLDER), FALSE);
		}else{
			CheckDlgButton(hDlg, IDC_RADIO_SELFOLDER, 1);
		}
		for(i = 0; i < TargetDirCnt; i++){
			if(*(TargetDir[i]) != '\0'){
				SendDlgItemMessage(hDlg, IDC_LIST_FOLDER, LB_ADDSTRING, 0, (LPARAM)TargetDir[i]);
			}
		}
		break;

	case WM_NOTIFY:
		return OptionNotifyProc(hDlg, uMsg, wParam, lParam);

	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case IDC_RADIO_ALL:
		case IDC_RADIO_SELFOLDER:
			if(IsDlgButtonChecked(hDlg, IDC_RADIO_ALL) == 0){
				EnableWindow(GetDlgItem(hDlg, IDC_LIST_FOLDER), TRUE);
			}else{
				EnableWindow(GetDlgItem(hDlg, IDC_LIST_FOLDER), FALSE);
			}
			break;

		case IDC_BUTTON_ADD:
			if(SendMessage(GetDlgItem(hDlg, IDC_LIST_FOLDER), LB_GETCOUNT, 0, 0) >= 100){
				break;
			}
			*buf = '\0';
			SendMessage(WWWCWnd, WM_FOLDER_SELECT, (WPARAM)hDlg, (LPARAM)buf);
			if(*buf != '\0'){
				SendDlgItemMessage(hDlg, IDC_LIST_FOLDER, LB_ADDSTRING, 0, (LPARAM)buf);
			}
			break;

		case IDC_BUTTON_DELETE:
			i = SendMessage(GetDlgItem(hDlg, IDC_LIST_FOLDER), LB_GETCURSEL, 0, 0);
			if(i < 0 || MessageBox(hDlg, "폜Ă낵łH", "폜", MB_ICONQUESTION | MB_YESNO) == IDNO){
				break;
			}
			SendMessage(GetDlgItem(hDlg, IDC_LIST_FOLDER), LB_DELETESTRING, i, 0);
			SendMessage(GetDlgItem(hDlg, IDC_LIST_FOLDER), LB_SETCURSEL, i, 0);
			break;

		case IDOK:
			if(IsDlgButtonChecked(hDlg, IDC_RADIO_ALL) == 1){
				TargetFlag = 0;
			}else{
				TargetFlag = 1;
			}

			TargetDirCnt = SendMessage(GetDlgItem(hDlg, IDC_LIST_FOLDER), LB_GETCOUNT, 0, 0);
			for(i = 0; i < TargetDirCnt; i++){
				SendDlgItemMessage(hDlg, IDC_LIST_FOLDER, LB_GETTEXT, i, (LPARAM)TargetDir[i]);
			}

			wsprintf(ini_path, "%s\\upMail.ini", CuDir);

			WritePrivateProfileString("TARGET", NULL, NULL, ini_path);

			wsprintf(buf, "%d", TargetFlag);
			WritePrivateProfileString("TARGET", "TargetFlag", buf, ini_path);
			
			wsprintf(buf, "%d", TargetDirCnt);
			WritePrivateProfileString("TARGET", "TargetDirCnt", buf, ini_path);
			for(i = 0; i < TargetDirCnt; i++){
				wsprintf(buf, "TargetDir-%d", i);
				WritePrivateProfileString("TARGET", buf, TargetDir[i], ini_path);
			}
			break;

		case IDPCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}


/******************************************************************************

	SetOptions

	IvVʂ̕\

******************************************************************************/

int SetOptions(HWND hWnd, HINSTANCE hInst)
{
	PROPSHEETPAGE psp;
	PROPSHEETHEADER psh;
	HPROPSHEETPAGE hpsp[4];

	ghinst = hInst;
	WWWCWnd = hWnd;

	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT;
	psp.hInstance = hInst;

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_OPTION);
	psp.pfnDlgProc = OptionSendProc;
	hpsp[0] = CreatePropertySheetPage(&psp);

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_HEADER);
	psp.pfnDlgProc = OptionHeaderProc;
	hpsp[1] = CreatePropertySheetPage(&psp);

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_MAKE);
	psp.pfnDlgProc = OptionMakeProc;
	hpsp[2] = CreatePropertySheetPage(&psp);

	psp.pszTemplate = MAKEINTRESOURCE(IDD_DIALOG_FOLDER);
	psp.pfnDlgProc = OptionFolderProc;
	hpsp[3] = CreatePropertySheetPage(&psp);

	ZeroMemory(&psh, sizeof(PROPSHEETHEADER));
	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_NOAPPLYNOW;
	psh.hInstance = hInst;
	psh.hwndParent = hWnd;
	psh.pszCaption = "Mݒ";
	psh.nPages = sizeof(hpsp) / sizeof(HPROPSHEETPAGE);
	psh.phpage = hpsp;
	psh.nStartPage = 0;

	PropertySheet(&psh);
	return 0;
}
/* End of source */
