/**************************************************************************

	WWWC (dll)

	wwwcdll.h

	(C) Copyright 1996-2000 By Tomoaki Nakashima. All right reserved.
		http://www.nakka.com/
		nakka@nakka.com

**************************************************************************/

/**************************************************************************
	Define
**************************************************************************/

/* EBhẼRg[ */
#define WWWC_TB						102					/* ToolBar */
#define WWWC_SB						103					/* StatusBar */
#define WWWC_COOL					104					/* ReBar */
#define WWWC_LIST					1002				/* ListView */
#define WWWC_TREE					1114				/* TreeView */

/* \PbgbZ[W */
#define WM_WSOCK_GETHOST			(WM_USER + 1)		/* zXg擾郁bZ[W */
#define WM_WSOCK_SELECT				(WM_USER + 2)		/* 񓯊select̃bZ[W */

/* `FbNbZ[W */
#define WM_CHECKEND					(WM_USER + 3)		/* ACẽ`FbNIm点郁bZ[W */
#define WM_ITEMCHECK				(WM_USER + 4)		/* ACẽ`FbNJnv */

/* f[^vbZ[W */
#define WM_GETVERSION				(WM_USER + 5)		/* WWWC̃o[W擾 */
#define WM_GETCHECKLIST				(WM_USER + 6)		/* `FbÑACeXg擾 */
#define WM_GETCHECKLISTCNT			(WM_USER + 7)		/* `FbÑACeXg̐擾 */
#define WM_SETITEMLIST				(WM_USER + 8)		/* ACe̒ǉ */

/* INIt@CbZ[W */
#define WM_WWWC_GETINI				(WM_USER + 20)		/* INIt@Cݒǂݒ */
#define WM_WWWC_PUTINI				(WM_USER + 21)		/* INIt@Cɐݒ */

/* tH_상bZ[W */
#define WM_FOLDER_SAVE				(WM_USER + 31)		/* JĂtH_̓eۑ */
#define WM_FOLDER_LOAD				(WM_USER + 32)		/* JĂtH_̓eǂݒ */
#define WM_FOLDER_GETPATH			(WM_USER + 33)		/* tH_̃pX擾 */
#define WM_FOLDER_GETWWWCPATH		(WM_USER + 34)		/* tH_WWWCł̃pX擾 */
#define WM_FOLDER_SELECT			(WM_USER + 35)		/* tH_IẴpX擾 */


/* ACȅ */
#define ST_DEFAULT					0					/* ʏ */
#define ST_UP						1					/* UP */
#define ST_ERROR					2					/* G[ */
#define ST_TIMEOUT					4					/* ^CAEg */

/* ACȐ */
#define ICON_ST_NOCHECK				1					/* `FbNҋ@ */
#define ICON_ST_CHECK				2					/* `FbN */

/* ߂l */
#define CHECK_ERROR					-1					/* G[ */
#define CHECK_SUCCEED				0					/*  */
#define CHECK_NO					1					/* ҋ@ */
#define CHECK_END					2					/* `FbNI */

/* hbvt@C̖߂l */
#define DROPFILE_NONE				0					/*  */
#define DROPFILE_NEWITEM			1					/* ACe쐬 */

/* c[stO */
#define TOOL_EXEC_PORP				0					/* vpeB */
#define TOOL_EXEC_ITEMMENU			1					/* ACej[ */
#define TOOL_EXEC_WINDOWMENU		2					/* EBhEj[ */
#define TOOL_EXEC_START				4					/* N */
#define TOOL_EXEC_END				8					/* I */
#define TOOL_EXEC_CHECKSTART		16					/* `FbNJn */
#define TOOL_EXEC_CHECKEND			32					/* `FbNI */
#define TOOL_EXEC_CHECKENDUP		64					/* `FbNIōXV̂Ƃ */
#define TOOL_EXEC_CHECKENDNOUP		128					/* `FbNIōXVȂ̂Ƃ */
#define TOOL_EXEC_SYNC				256					/* c[I܂őҋ@ (DLL̏ꍇ͖) */
#define TOOL_EXEC_INITITEM			512					/* sɃACe */
#define TOOL_EXEC_MENUDEFAULT		1024				/* ftHg */
#define TOOL_EXEC_NOTCHECK			2048				/* `FbN͎sȂ */
#define TOOL_EXEC_SAVEFOLDER		4096				/* sOɃtH_̓eۑĎsɓǂݒ */

/* `FbN̎ */
#define CHECKTYPE_ITEM				1					/* ACe`FbN */
#define CHECKTYPE_ALL				2					/* SẴACe`FbN */
#define CHECKTYPE_TREE				4					/* Kw`FbN */
#define CHECKTYPE_ERROR				8					/* G[ACe`FbN */
#define CHECKTYPE_AUTO				16					/* `FbN */


/**************************************************************************
	Struct
**************************************************************************/

/* ACe */
struct TPITEM{
	long iSize;						/* \̂̃TCY */

	long hItem;						/* ACei[ĂtH_̃nh (HTREEITEM) */

	char *Title;					/* ^Cg */
	char *CheckURL;					/* `FbNsURL */
	char *Size;						/* TCY */
	char *Date;						/* XV */
	int Status;						/* ACȅ (ST_) */

	char *CheckDate;				/* `FbN */
	char *OldSize;					/* XV */
	char *OldDate;					/* TCY */

	char *ViewURL;					/* \URL */
	char *Option1;					/* IvV 1 */
	char *Option2;					/* IvV 2 */
	char *Comment;					/* Rg */

	int CheckSt;					/* `FbNtO */

	char *ErrStatus;				/* G[ */
	char *DLLData1;					/* DLLpf[^ 1 */
	char *DLLData2;					/* DLLpf[^ 2 */

/* ȉۑȂ */
	int IconStatus;					/* ACȐ (ICON_ST_) */

	int Soc1;						/* \Pbg1 */
	int Soc2;						/* \Pbg2 */
	HANDLE hGetHost1;				/* zXg̃nh1 */
	HANDLE hGetHost2;				/* zXg̃nh1 */
	long Param1;					/* DLLplongl1 */
	long Param2;					/* DLLplongl2 */
	long Param3;					/* DLLplongl3 */
	long Param4;					/* DLLplongl4 */
	int user1;						/* DLLpintl1 */
	int user2;						/* DLLpintl2 */

	BOOL RefreshFlag;				/* ĕ`tO */
};


/* vgRݒ */
struct TPPROTOCOLSET{
	long iSize;						/* \̂̃TCY */

	char Title[256];				/* ^Cg */
	char FuncHeader[256];			/* ֐̐擪ɕt镶 */
	char IconFile[256];				/* ACRt@C */
	int IconIndex;					/* ACRCfbNX */
	char UpIconFile[256];			/* UPACRt@C */
	int UpIconIndex;				/* UPACRCfbNX */
};

/* vgRj[ */
struct TPPROTOCOLMENU{
	char Name[256];					/* j[ */
	char Action[256];				/* s̃ANV */
	BOOL Default;					/* ftHgtO */
	int Flag;						/* tO */
};

/* vgR */
struct TPPROTOCOLINFO{
	long iSize;						/* \̂̃TCY */

	char Scheme[256];				/* ΉXL[} (: "http://\thttps://") */
	char NewMenu[256];				/* VK쐬j[ */
	char FileType[256];				/* D&Dŏ\ȃt@C̊gq (: "txt\tdoc\tdat") */
	struct TPPROTOCOLMENU *tpMenu;	/* ACej[ɒǉ鍀 */
	int tpMenuCnt;					/* ACej[ɒǉ鍀ڂ̐ */
};


/* c[ݒ */
struct TP_TOOLS{
	long iSize;						/* \̂̃TCY */

	char title[256];				/* ^Cg */
	char func[256];					/* ֐ */
	char Protocol[256];				/* ΉvgR (: http,ftp) */
	int MenuIndex;					/* j[ʒu */
	int Action;						/* stO */
};

